<%-- 
    Document   : dataSmartHelp
    Created on : May 16, 2014, 4:50:07 PM
    Author     : lutzK
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>

<%@taglib prefix="f" uri="http://java.sun.com/jsf/core"%>
<%@taglib prefix="h" uri="http://java.sun.com/jsf/html"%>


<div align="left" style="padding-left:2cm; padding-right:2cm;">
        
        <h1>DataSmart Help</h1>
        
        <h2>Disclaimer</h2>
        
     
        
        This program is provided in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. The software may be used
        at your own risk. If you decide to use Calypso in published work, it is YOUR responsibility
        to ensure the correctness and consistency of the data.

        <h1>Tutorial</h1>
        To get familiar with Calypso, please follow the example analysis in our
        <a href="faces/dsTutorial.jsp">Tutorial</a>.

       
        <h1>Detailed Description</h1>
        Click on the title to get directly to the section.</br> 
        <a href="#menumain">Main Menu</a></br>  
        <a href="#upload">Upload Files</a></br>      
        <a href="#formatdata">File Format Data File</a></br>
        <a href="#formatannot">File Format Meta Data File</a></br>
        <a href="#generaloptions">General Options</a></br>
        <a href="#summary">Summary</a></br>
        <a href="#rarefaction">Rarefaction</a></br>
        <a href="#sampleplots">Sample Plots</a></br>
        <a href="#groupplots">Group Plots</a></br>
        <a href="#statisticalanalysis">Statistical analysis</a></br>
        <a href="#multivariateanalysis">Multivariate analysis</a></br>
        <a href="#diversity">Diversity</a></br>
        <a href="#paired">Paired analysis</a></br>
        <a href="#regression">Regression</a></br>
        <a href="#biomarker">BM (Biomarker)</a></br>
        <a href="#faq">FAQ</a></br>
       <!--  <a href="youtu.be/77R2Y9bg_nA" target="_blank">Hierarchy</a>-->
        <h2><a name="menumain">Main Menu</a></h2>
        The main menu allows you to change between different Calypso views. The main menu is shown
        on the top of each Calypso view:

        <p/>
        <img src="resources/figures/menu.png" width="800" height="35" alt="menu"/>


        <h2><a name="upload">Upload Files</a></h2>

        To use Calypso, first upload an meta data and a data file. The data file contains the number of reads assigned to each
        taxonomic group/OTU, the meta data file contains further description of each sample.

        To test calypso using example files, select the button "Start Demo Project" on the Home/Upload page.

        <h3>Use Calypso for QIIME output files</h3>

        <ol>
            <li>Install <a href="http://www.qiime.org/ ">QIIME</a> and follow the <a href="http://qiime.org/tutorials/tutorial.html">tutorial</a></li>
           
            <li>Generate OTU tables using pick_otus_through_otu_table.py</li>
            <li>Assign reads to a taxonomy by assign_taxonomy.py</li>
            
            <li>Create a Calypso meta data file for your samples, e.g. using Excel. </li>
            <li>Go to the <a href="faces/uploadFiles.jsp">Data Upload Page</a> and upload
                the Calypso meta data file and the biom file generated by QIIME.
        </ol>

        <h3>Upload data and meta data file</h3>
        Select "Home" in the main menu. Select your meta data file via "Choose File" and press "Upload".
        Select your data file via the "Choose File" button and press "Upload". Set "Min Proportion" to exclude low abundant taxa/OTUs
        (see further details under "General Options" below).
        <p/>
        Example meta data and data files can be downloaded from here:
            <a href="resources/ExampleCounts.csv">Example Data File
            </a>, <a href="resources/ExampleAnnotation.csv">Example Meta Data</a>.
        
        <h4><a name="formatdata">File Format Data File</a></h4>
        The data file is in comma separated format. Example:
        <p/>
        Phylum, Header, Sample42, Sample43, Sample45, Sample46, Sample29, Sample30, Sample31<br/>
        Phylum, Anaerococcus, 0, 0, 0, 0, 0, 0, 0<br/>
        Phylum, Bacteroidetes, 144, 55, 294, 47, 5, 226, 0<br/>
        Phylum, Actinobacteria, 4, 0, 283, 25, 21, 48, 33<br/>
        Phylum, Firmicutes, 998, 1021, 4095, 234, 585, 513, 1200<br/>
        <br/>
        Class, Header, Sample42, Sample43, Sample45, Sample46, Sample29, Sample30, Sample31<br/>
        Class, Bacilli, 897, 988, 169, 209, 354, 438, 645<br/>
        Class, Gammaproteobacteria, 1154, 237, 209, 1343, 1381, 3198, 1148<br/>
        Class, Unclassified, 2, 136, 524, 3, 2, 16, 7<br/>
        <br/>
        Order, Header, Sample42, Sample43, Sample45, Sample46, Sample29, Sample30, Sample31<br/>
        Order, Clostridiales, 99, 24, 892, 25, 231, 73, 554<br/>
        Order, Erysipelotrichales, 0, 8, 2895, 0, 0, 0, 0<br/>
        Order, Unclassified, 66, 137, 529, 13, 104, 33, 120<br/>
        <br/>
        Family, Header, Sample42, Sample43, Sample45, Sample46, Sample29, Sample30, Sample31<br/>
        Family, Coriobacteriaceae, 0, 0, 277, 0, 0, 2, 0<br/>
        Family, Lachnospiraceae, 1, 17, 317, 0, 0, 0, 3<br/>
        Family, Unclassified, 72, 152, 859, 15, 108, 44, 130<br/>
        <br/>
        Genus, Header, Sample42, Sample43, Sample45, Sample46, Sample29, Sample30, Sample31<br/>
        Genus, Streptococcus, 488, 0, 0, 208, 330, 333, 615<br/>
        Genus, Pseudomonas, 511, 17, 4, 560, 600, 3154, 536<br/>
        Genus, Unclassified, 594, 224, 1486, 603, 780, 89, 624<br/>
        <br/>
        OTU, Header, Sample42, Sample43, Sample45, Sample46, Sample29, Sample30, Sample31<br/>
        OTU, Escherichia/Shigella, 0, 132, 59, 0, 0, 0, 0<br/>
        OTU, Streptococcus, 488, 0, 0, 208, 330, 333, 615<br/>
        OTU, Unclassified, 594, 224, 1486, 603, 780, 89, 624<br/>
        <p></p>
        The first row is a header line; the second column must have the tag "Header".
        The header line must follow the following format (a new header line has to be supplied for each rank):
        <p></p>
        <table border="1" bgcolor=#FFFFFF>
            <tr><th align="left">Column</th><th align="left">Description</th></tr>
            <tr><td>Rank</td><td>The rank of the respective taxa, e.g. Phylum, Family, Genus, OTU.</td></tr>
            <tr><td>Header</td><td>The tag "Header" indicates that this is a header line. This tag has to be provided.</td></tr>
            <tr><td>Sample1</td><td>Identifier/Name of the first sample.</td></tr>
            <tr><td>Sample2</td><td>Identifier/Name of the second sample.</td></tr>
            <tr><td>...</td><td>...</td></tr>

        </table>
        <p></p>
        Each following row of the data file contains the number of reads assigned to the respective taxa/OTU:
        <p></p>
        <table border="1" bgcolor=#FFFFFF>
            <tr><th align="left">Column</th><th align="left">Description</th></tr>
            <tr><td>Rank</td><td>The rank of the respective taxa, e.g. Phylum, Family, Genus, OTU.</td></tr>
            <tr><td>Taxa</td><td>Name of the taxonomic group or OTU, e.g. Firmicutes, Bacteroidetes or "OTU 467". </td></tr>
            <tr><td>Sample1</td><td>Number of assigned reads from first sample, e.g. "154"</td></tr>
            <tr><td>Sample2</td><td>Number of assigned reads from second sample, e.g. "349"</td></tr>
            <tr><td>...</td><td>...</td></tr>

        </table>

        <p></p>
        Download <a href="resources/ExampleCounts.csv">Example Data File</a> (Right mouse click -> "Save as")
        <p></p>
        Unclassified is a special tag for the number of reads that could not be assigned to any of the listed classes (taxa, OTUs, etc).
        Unclassified will be excluded during some type of analysis, e.g. in the rarefaction analysis of community diversity.


        <h4><a name="formatannot">File Format Meta Data File</a></h4>
        The meta data file is in comma separated format with at least 6 columns.
        Each row contains the description for one sample.
        The first row is a header. 
        
        The header line must NOT start with "#"! The file can be created or modified in Excel. Save
        the file in comma separated format, the fields must not be quoted. To control the
        file format open the file in Notepad or WordPad. The file must have the following format:
        <p></p>

         <table border="1" bgcolor=#FFFFFF>
            <tr><th align="left">Column</th><th align="left">Description</th></tr>
            <tr><td>Sample id</td><td>A unique identifier of each sample. This identifier has to match the sample identifier in the
                    data file.</td></tr>
            <tr><td>Label</td><td>A unique label that will be displayed for each sample
                    in the generated figures.
                </td></tr>
            <tr><td>Pair</td><td>Used to specify the person/animal/location/environment
                    from which a sample has been collected, e.g. rat1, rat2, .... This
                    information is used in paired tests, e.g. to test the abundance of bacterial groups in subjects before and after
                    treatment or for longitudinal data. 
                    For unpaired data, set a different "Pair" for each sample
                    (e.g. 1 to N for N samples).</td></tr>
            <tr><td>Primary Group</td><td>Primary sample groups, e.g. cases and controls</td></tr>
            <tr><td>Secondary Group</td><td>Secondary sample groupse, e.g. 
                    time point at which a
                    sample has been collected, or location. Example:
                    T1, T2, T3.. or stomach, caecum, colon, faeces or T1 stomach, T2 stomach, 
                    T1 caecum, T2 caecum,...
                    This information is used to colorize samples (e.g. in PCA or PCoA plots),
                    for the analysis of longitudinal data (time series) and nested anova.
                </td></tr>
            <tr><td>Include</td><td>Specifies if the sample should be included (set to "1") or excluded (set to "0") from the analysis.
                    This can be used to exclude outliers, problematic samples, or entire groups, time points or sample locations.</td></tr>
            <tr><td>Environmental variable 1</td><td>Optional numeric or categorical environmental/clinical variable.
                    This allows to identify the impact of environmental or clinical variables on the community
                    composition by multivariate analysis, including RDA, CCA, correlation or multivariate regression.
                    Example environmental variables are BMI, age, tissue,
                    blood sugar level, temperature, time of sampling, sample location, or ph. Categorical
                    variables must be encoded categorical (e.g. "T1", "T2", ..). 
                    Categorical variables must not be encoded numeric (e.g. 1,2,3,...). 
             
                    You can specify no or multiple different environmental variables.
                </td></tr>
            <tr><td>Environmental variable 2</td><td>A second optional environmental variable.
                </td></tr>
            <tr><td>Environmental variable 3</td><td>A third optional environmental variable.</td></tr>
            <tr><td>...</td><td>...</td></tr>
        </table>
        
        <h5>Example:</h5>

        Sample ID, Label, Pair, Primary Group, Secondary Group, Include, BMI, ph, tissue<br/>
        Sample42, High  29 T1, M29, High, T1, 1, 18.2, 5, lung<br/>
        Sample43, High  29 T2, M29, High, T2, 1, 18.2, 6, lung<br/>
        Sample45, High  30 T1, M30, High, T1, 1, 32.1, 5, lung<br/>
        Sample46, High  30 T2, M30, High, T2, 1, 32.1, 7, sputum<br/>
        Sample29, Low 26 T1, M26, Low, T1, 1, 22.3, 8, sputum<br/>
        Sample30, Low 26 T2, M26, Low, T2, 1, 22.3, 8, sputum<br/>
        Sample31, Low  27 T1, M27, Low, T1, 1, 23.4, 9, lung<br/>
        Sample32, Low  27 T2, M27, Low, T2, 1, 23.4, 4, lung<br/>
        Sample34, Normal  37 T1, M37, Normal, T1, 1, 31.1, 5, lung<br/>
        Sample35, Normal  37 T2, M37, Normal, T2, 1, 31.1, 6,lung<br/>
        Sample39, Normal  42 T1, M42, Normal, T1, 0,22, 8, sputum<br/>

        <p/>

       
        Download <a href="resources/ExampleAnnotation.csv">Example Meta Data</a> (Right mouse click -> "Save as")

        <h2><a name="generaloptions">General Options</a></h2>
        The following options are available in most Calypso views:
        <p><p>
        <table border="1" bgcolor=#FFFFFF>
            <tr><th align="left">Field</th><th align="left">Description</th></tr>
            <tr><td>Level</td><td>The taxonomic rank to be analyzed, e.g. Phylum, Genus or OTU.</td></tr>
            <tr><td>Figure Format</td><td>The file format of generated figures
                (PNG, PDF or SVG).</td></tr>
            <tr><td>Order</td><td>The order of samples in the generated figures.
                    Samples can be ordered by their primary group, secondary group, pair,
                    or label.</td></tr>
            <tr><td>Color</td><td>Color palette for plots, e.g. "Grey colors", "GreenRed" or "Heatmap"</td></tr>
            <tr><td>Min Proportion</td><td>Filter to exclude low abundant taxa/OTUs. Used to remove 
                    noise and to reduce the displayed information. Only those taxa/OTUs are included
                    that have at least "Min Proportion" reads in at least on sample. The default value in
                    most views is 0.5. In this case, only those taxa/OTUs are included that have
                    a frequency above 0.5% in at least one sample.
                    The value is specified in percentage. For example, to exclude taxa/OTUs with a frequency below 2%, set Min Proportion
                    to "2". Value range: 0-100. Real numbers are supported, e.g. 0.5.

                </td></tr>
            <tr><td>Secondary Group</td><td>Used to filter samples by their secondary group. Select "All" to include all
                    samples.</td></tr>
            <tr><td>Distance</td><td>Distance metric for comparing global community profiles. Recommendation: Use the Jaccard distance. The available distances are explained in the <a href="http://cran.r-project.org/web/packages/vegan/vegan.pdf" target="_blank">vegan documentation</a>.
                </td></tr>
            <tr><td>Resolution</td><td>Resolution of the generated plot in dpi. Allowed range: 20-1000</td></tr>
            <tr><td>Width</td><td>Width of generated plot in mm.</td></tr>
            <tr><td>Height</td><td>Height of generated plot in mm.</td></tr>
        </table>

        <h2><a name="summary">Summary</a></h2>
        This page provides a basic descriptive overview of the uploaded data. Displayed are: The number of reads per sample, reads
        per taxon or OTU, and the number of samples in which each taxon/OTU has been detected.

        <p/>
        <img src="resources/figures/summary.png" width="450" height="343" alt="summary"/>


        <h2><a name="rarefaction">Rarefaction</a></h2>
        This view provides a rarefaction analysis to assess the coverage of the original microbial communities by 16S sequences.
        In the rarefaction analysis, 16S sequences are randomly drawn from each sample
        and the number of observed taxa/OTUs is plotted versus the number of randomly drawn
        sequences.

        <p/>
        <img src="resources/figures/rarefac.png" width="600" height="400" alt="rarefac"/>



        <h2><a name="sampleplots">Sample Plots</a></h2>
        Visualize community profiles of each individual sample. Different plots are available,
        including barcharts, heatmaps or bubble
        plots.
        <p></p>
        Colors are randomly allocated. Simply hit "Draw Chart" again to change colors.
        <p>
            See "General Options" above for a description of all available options.

            <p/>
            <img src="resources/figures/barchart.png" width="500" height="300" alt="barchart"/>
            <img src="resources/figures/bubble.png" width="500" height="300" alt="bubble"/>



        <h2><a name="groupplots">Group Plots</a></h2>
        Sample groups are compared, e.g. as as boxplot, stripchart,
        or bubbleplot.
        Significantly differentially abundant taxa are identified by Anova or rank test.
        The following plots are available:

        
       
        <h4>Rank Test Plot</h4>
        Significantly differentially abundant bacterial groups are shown as barchart (p < 0.05, Kruskal-Wallis test).
        Pair-wise comparisons are done by Wilcoxon rank test. Significant differences are annotated
        by *: p<0.05, **: p<0.01, ***: p<0.001

        <h4>Anova Plot</h4>
        Significantly differentially abundant bacterial groups are shown as barchart (p < 0.05, ANOVA). 
        Standard error is depicted as error bars. 
        Pair-wise comparisons are done by t-test and annotated
        as *: p<0.05, **: p<0.01, ***: p<0.001


        <p/>
        <img src="resources/figures/anova.png" width="700" height="400" alt="anova"/>

        <h4>Nested Anova</h4>
        Use a nested anova if you 
        have a nested experiment design (<a href="http://udel.edu/~mcdonalt/statnested.html" target="_blank">Handbook of Biological Statistics</a>). 
        Example: Measure the impact of a treatment on lab animals
        in different cages, with treatment as primary group and cage as 
        nested group.
        In the nested anova, the "primary group" (3rd column of meta data file) is used as 
        group (e.g. treatment), the secondary group (5th column of meta data
        file) is used as subgroup (nested group).
        Standard error is shown
        as error bars. Only sign. differentially abundant bacterial groups are displayed
        (p < 0.05, ANOVA). Pair-wise comparisons are done by t-test and annotated
        as *: p<0.05, **: p<0.01, ***: p<0.001. 
        
        

        <h4>GlobCommunityComp</h4>
        Compare global community profiles. Set
        "Type" to "GlobCommunityComp". Intra-group distances are compared to 
        inter-group distances by Wilcoxon rank test.
        The respective p-values are depicted in the figure "P-values intra/inter group distances".
        Additionally median distances and median Pearson correlation between community profiles are shown.
        

        <h2><a name="statisticalanalysis">Statistical Analysis</a></h2>
        Select "Stats" in the main menu to identify significantly differentially abundant taxa/OTUs.

        <p></p>

        Available tests: Parametric tests (select Anova, "Nested Anova" or anova+) and none parametric tests (select RankTest).<p>
        
        Select "Nested Anova" for nested designs (<a href="http://udel.edu/~mcdonalt/statnested.html" target="_blank">Handbook of Biological Statistics</a>). 
        In this case, the primary group (3rd column of meta data file) is used as 
        group (e.g. treatment), the secondary group (5th column of meta data
        file) as subgroup (nested variable, e.g. animal cage). The following test is run in R:
        aov(abundance(taxa) ~ primaryGroup/secondaryGroup).<p>
        
        "anova+" multivariate anova to identify taxa/OTUs effected by environmental variables. 
        Numeric environmental variables are categorized automatically (e.g. if an environmental variable is in the range
        0 - 200 it could be divided into the categories 0-50,50-100,100-150,150-200).
        An anova is run for each taxa/OTU, the abundance of each taxa/OTU is 
        included as dependent variable, each categorical environmental variable as 
        explanatory variable. The following test is run in R: aov(OTU abundance ~ env1 + env2 
        + ...). Anova is run without interaction terms.
        <p/>
        If RankTest is selected, a Wilcoxon test is performed if 2 groups are compared,
        otherwise a Kruskal-Wallis test.<p>
        <p/>
        Associations between environmental variables and abundance of individual
        taxa can also be identified by the multivariate Random Forest. The score
        indicates the strength of the association. The score is the mean decrease in 
        accuracy of the decision tree if the respective taxa is removed. The following
        function is called in R: 
        randomForest(group~taxa1+taxa2+taxa3+...,importance=T,proximity=F,ntree=10000,mtry=20)
        <p/>
        Recommendation: Select "RankTest".

        <p></p>
        P-values are adjusted for multiple testing by Bonferroni (P.adj) and false discovery rate (FDR q-value). Click on the header to
        order the data table.

        <p/>
        The p-value distribution is also plotted as histogram and compared to the expected
        distribution by a qq-plot. A uniform p-value distribution (red "Expected" line)
        indicates that low p-values are observed by chance only. A p-value distribution with
        more low p-values than expected by chance indicates that
        at least some of the observed differences are relevant and not observed by chance only (as in the figure shown below).

        <p/>

        <img src="resources/figures/phist-otu.png" width="500" height="300" alt="phist-otu"/>




        <h2><a name="multivariateanalysis">Multivariate Analysis</a></h2>
        
         The following unsupervised multivariate methods are available: Network, PCA, PCoA, Dendrogram,
            Heatmap, DCA, and NMDS. Additionally, the following
            supervised multivariate techniques are provided: RDA, CCA, and DAPC.
            Associations between environmental variables and global community composition 
            can be assessed by the multivariate methods
            PCA+, DCA+, NMDS+, RDA+, CCA+, Heatmap+, and Hierarchical clustering.

        <h4>Options</h4>

        <table border="1" bgcolor=#FFFFFF>
            <tr><th align="left">Option</th><th align="left">Description</th></tr>
          
            <tr><td>Color by</td><td>Samples in the generated plots are colored
                    by the selected feature (e.g. primary group, secondary group or pair).
                    The selected grouping is also used as group variable in the
                    PERMDISP2, Anosim, RDA, CCAl, DAPC and Adonis.
                </td></tr>
            <tr><td>Components</td><td> The components to be plotted (e.g. principle components of PCA)</td></tr>
            <tr><td>Loadings</td><td>If selected the 8 bacterial groups with the highest variance (highest loadings) are plotted in the PCA
                    plot. These are the 8 bacterial groups with the largest contribution to the variance in the data and that are well
                    represented by PC1 and PC2.</td></tr>
            <tr><td>Sample IDs</td><td>If selected, the labels are displayed for each sample.</td></tr>
            <tr><td>Distance method</td><td>The dissimilarity measure used to
                compare the similarity of community composition profiles. 
                Used for all distance-matrix based multivariate methods 
                (PCoA, hierarchical clustering, network and heatmap).</td>
            </tr>
            <tr><td>Edge Min Similarity</td><td>Minimal similarity between
                samples to be connected by an edge in network (if "Type" is set to
                "Network").</td></tr>
            <tr><td>Vertex size</td><td>Network vertex size.</td></tr>
        
        </table>

        <p>
            For the remaining options, see above under "General Options".

           

        <h4>Network</h4>
        Samples are represented as nodes, samples with a similar community composition 
        are connected with edges (similarity >
        Edge Min Similarity). Set the Edge Min Similarity parameter to increase/decrease the number
        of connected samples. The used distance index can be set by "Distance Method".
        Recommendation: Jaccard distance.

        <p/>
        <center>
            <img src="resources/figures/network3.png" width="400" height="400" alt="network1"/>

        </center>

        <h4>Heatmap+</h4>
        
        Pearson's correlation between abundance of taxa and
        environmental parameters visualized as color code. Recommended color palettes:
        "yellowblue", "redgreen", "heat" and "heat2".

        <p/>
        <center>
            <img src="resources/figures/heatmapp.png" width="700" height="450" alt="heatmapp"/>
        </center>

        <h4>PCA and PCA+</h4>
        PCA ordinates samples in two dimensions according to the main variance in the dataset. PCA+ overlays
        environmental variables. 

        <p/>
        <img src="resources/figures/pcap.png" width="500" height="350" alt="pcap"/>

        <h4>RDA, RDA-F and RDA+</h4>
        Redundancy analysis, a popular multivariate supervised ordination method in ecology (see vegan R
        package for more details). RDA allows identification of complex microbiome-environment
        interactions. 
        
       <p/>
       "RDA" identifies if the community composition is significantly different
       between the different sample groups. The
       significance of the clustering is given as p-value. The following
       command is executed in R: rda(OTU-table ~ sample groups) (vegan), where OTU-table is a matrix of
       relative OTU abundance.
       <p/>
       "RDA-F" identifies if variance in community structure can be attributed to 
       the primary group, secondary group or sample pair. The following command is executed in R: rda(OTU-table ~ primaryGroup + seoncaryGroup + sample pairs), where OTU-table is either a matrix of
       relative OTU or relative taxa abundance.
       <p/>
       "RDA+" identifies if variance in the community composition can be attributed to 
       environmental variables in a multivariate approach. 
       For each environmental variable a p-value is provided indicating if variance
       in community composition can be attributed to the respective variable.
       The following
       command is executed in R: rda(OTU-table ~ env1 + env2 + env3 + ...), where env1, env2, ... are 
       environmental variables and OTU-table is a matrix of
       relative OTU abundance.

       <h4>DAPC</h4>
       Discriminant Analysis of Principal Components as described by Jombart et al. BMC Genetics 2010.
       
         <h4>CCA, CCA-F and CCA+</h4>
        Canonical Correspondence analysis (CCA) is a supervised, multivariate technique similar to RDA. CCA can analyze complex 
        bacteria-environment interactions and identifies 
        variance in the relative abundance of bacteria
        that can be attributed to each included environmental variable. For each environmental variable a p-value is given, 
        indicating if this variable significantly impacts bacterial community composition (CCA+).
        
        
        <p/>
        CCA 
        identifies if sample groups significantly affect
        community composition. A PCA like figure is shown and 
        a p-value is calculated, indicating if the sample groups significantly
        impact community composition. The following command is executed in R:
        cca(relative OTU/taxa abundance ~ sample groups)
        <p/>
        CCA-F assesses if primary group, secondary group and
        pair affect bacterial community composition in a multivariate approach. 
        The following command is executed 
        in R: cca(relative OTU/taxa abundance ~ primaryGroup
        + secondaryGroup + pair).
        <p/>
        "CCA+" identifies environmental variables
        impacting bacterial community composition in a multivariate analysis. 
        For each environmental variable a p-value is giving, which
        indicates the 
      significance of the association. The following command is run
        in R: cca(relative OTU/taxa abundance ~ env1 + env2 + env3 + ...), where env1, env2, ... are environmental
        variables.

<p/>
<img src="resources/figures/cca2.png" width="500" height="345" alt="cca2"/>

<h3>Adonis</h3>
        Adonis is a multivariate technique analogous to MANOVA and describes if variation in
        community composition can be attributed to different experimental treatments
        or control variables (see vegan R package for more details). Adonis describes if the community composition is different
        between groups. Adonis-F describes if variance in community composition can
        be attributed to primary groups, secondary groups and pair. Adonis+ describes if
        variance in community composition can be attributed to the different environmental
        variables.
      
        <h3>SVM LOOC</h3>
        SVM leave one out cross-validation (SVM LOOC) can be used to assess if two sample
        groups show a different bacterial community
        composition, or if the community profiles can be used to predict the group (class) of 
        samples. For example, the method could be used to analyze if the gut microbiota shows a different
        composition 
        between subjects with and without diabetes or to assess if the gut microbiota composition is a 
        predictive biomarker for diabetes. 
        <p/>
        SVM LOOC works iteratively. In each step, one sample is excluded and an SVM is trained
        to distinguish between two sample groups (e.g. diabetes and non-diabetes). The trained
        SVM is then applied to predict the group affiliation of the excluded sample. This is 
        repeated iteratively for each sample. Finally, the predicted group affiliations are 
        compared with the original group labels to calculate the classification accuracy (percentage
        of correctly predicted group labels), sensitivity (TP/(TP+FN) and specificity (TP/(TP+FP)).
        
        
        <h3>Distance Plots</h3>
        Distance plots visualize the distance/similarity of the community profiles.
        Available plots are PCoA, hierarchical clustering, heatmaps, CCA, PERMDISP2, anosim
        and adonis.

        <p></p>
        First, the pairwise distance of all sample pairs is computed.
        Different distance measures are available, including Jaccard, Yue & Clayton, Euclidian distance and Chao distance.
        Subsequently, the pairwise distance matrix is visualized by PCoA, dendrogram, heatmap, CCA,
        PERMDISP2, or anosim. For example, you can first run a PCoA to
        visually identify if samples from each group cluster together. 
        The significance of the clustering
        can then be identified by PERMDISP2 or anosim.

        <p></p>
       To test if the intra-group distances are smaller than the inter-group distances,
       run PERMDISP2, anosim, or "GlobCommunityComp" in the GroupPlots view.
        
        <h4>Recommendations: </h4> Use Jaccard distance.

        <h4>anosim and PERMDISP2</h4>
        Analyze if global community composition is significantly
        different between groups. Anosim compares between group distances and within group
        distances (distances of community profiles). PERMDISP2 visualizes the distances
        of each sample to the group centroid in a PCoA and gives a p-value for the significance
        of the grouping. See vegan R package for more details.

        
        <h4>PCoA</h4>
        Given a matrix of pair-wise
        distances between samples, a PCoA visualizes these in a 2 dimensional plot as best as possible. The Euclidian distance of two
        samples in a PCoA plot represents their pair-wise distance in the original matrix as best as
        possible.

        <bf>Interpretation:</bf>
        Distance of samples in 2 dimensional plot represents their similarity in community composition.

        <h4>Heatmap</h4>
        Visualization similarity of community profiles as heatmpal. 
        Recommended color: "blue1".

       
        <h2><a name="diversity">Diversity</a></h2>

        Visualize diversity of microbial communities. Different plots are available,
        including boxplots, stripcharts, barcharts, and rarefaction plots. "Shannon index" measures the overall diversity, 
        including both number of present OTUs and evenness. "Richness" measures the
        number of present OTUs. "Evenness" measures how evenly abundant the present OTUs
        are. "AbundancePlot" displays the size distribution (relative number
        of assigned reads) of OTUs. Error bars in stripcharts visualize standard deviation. 
        As species richness  depends on sample size, richness is estimated by rarefaction 
        analysis. Expected species richness in calculated from random subsamples of size 
        minTotal from the community, where minTotal is total number of reads of the smallest sample.
        Richness is computed using the rarefy() R function of the vegan package.

        <h2><a name="paired">Paired</a></h2>
        Paired analysis of paired samples (samples collected from the same individual). 
        Examples: Study the effects of drug treatment on the gut microbiota
        or monitor the composition of microbial communities over time.
        Secondary groups are compared, e.g. before and after treatment. Or
        the composition of the microbiota at different locations of the same individual,
        e.g. microbiota of the small intestine versus large intestine.
        
        <h4>Options</h4>
        
        <table border="1">
            <thead>
                <tr>
                    <th>Option</th>
                    <th>Description</th>
                </tr>
            </thead>
            <tbody>
                 <tr>
                    <td>G1 and G2</td>
                    <td>The two secondary groups to be compared in the paired
                        analysis.</td>
                </tr>
                <tr>
                    <td>Index</td>
                    <td>Diversity index used by the diversity
                    scatter plot ("DiversityScatter").</td>
                </tr>
                <tr>
                    <td>Test</td>
                    <td>Statistical test used for the paired
                        analysis, e.g. paired t-test or paired
                        Wilcoxon rank test.</td>
                </tr>
               
                <tr>
                    <td>Sample IDs</td>
                    <td>Show sample IDs in scatter plots.</td>
                </tr>
                
                <tr>
                    <td>Legend</td>
                    <td>Show figure legends.</td>
                </tr>
                <tr>
                    <td>Taxa</td>
                    <td>Taxa/OTU shown in taxa scatter plot ("TaxaScatter").</td>
                </tr>
                
            </tbody>
        </table>
        
     
        
        <h3>DiversityScatter</h3>
        Scatter plot of community diversity. Each dot represents the diversity
        of one individual at  two selected secondary groups (G1 versus G2).
        
        <h3>TaxaScatter</h3>
        Scatter plot of OTU/taxa abundance. Each dot represents the abundance
        of the selected OTU/taxa of one individual at  two selected secondary groups
        (G1 versus G2). Taxa/OTUs can be selected via the "Taxa" drop-down menu.
        
        <h3>BubblePlot</h3>
        Differences in OTU/taxa abundances are shown as bubble plot.
        
        <h3>StatsTable</h3>
        P-values and false discovery rate for paired statistical analysis
        (paired t-test or paired Wilcoxon rank test).
        
        
        <p/>
        <img src="resources/figures/taxa-paired.png" width="400" height="330" alt="taxa-paired"/>

        <img src="resources/figures/diversity-paired.png" width="400" height="330" alt="diversity-paired"/>

        <img src="resources/figures/bubble-paired.png" width="700" height="330" alt="bubble-paired"/>

        <p/>

        <h2><a name="network">Network</a></h2>
        Pearson's correlation between
        different taxa visualized as heatmap or network. This analysis allows identification
        of co-occurring and mutual exclusive taxa. "Network+" also includes
        numeric environmental variables. Taxa with a Pearson's correlation above Edge Min Similarity
        or below -1 * Edge Min Similarity are connected by an edge. Positive correlations are
        displayed in yellow, negative correlations in blue. Select "Layout By Correlation" to
        layout nodes based on a PCoA. 
        <p/>
        <center>
            <img src="resources/figures/network4.png" width="400" height="400" alt="network"/>
        </center>

        <h2><a name="regression">Regression</a></h2>
        Multivariate linear regression  allows identification of complex bacteria-environment associations.
        Example environmental variables are BMI, age,
        blood sugar, ph, temperature or iron. In Calypso, regression models generally have the
        form:
        <p>
            dp = env1 + env2 + env3 + env4 + ...
        </p>
        where dp is a dependent variable (such as the abundance of an OTU, the community
        diversity or the similarity in community composition) and env1 to envN are
        environmental variables. In the regression analysis, the abundance of each OTU, the
        community diversity or community composition of each sample are explained or
        "modeled" by the values of the included environmental parameters.
        <p>
            The following modes are available:
        <table border="1" bgcolor=#FFFFFF>
            <tr><th>Type</th><th>Description</th></tr>
            <tr><td>Taxa vs Envp</td><td>Identify associations between individual taxa and
                    environmental variables.</td></tr>
            <tr><td>Taxa Time Series</td><td>Analysis of longitudinal data.</td></tr>
            <tr><td>Diversity vs Envp</td><td>Identify associations between community
                    diversity and environmental variables.</td></tr>
            
        </table>

        <p></p>

        <h3>Details:</h3>

        <h4>Taxa vs Envp</h4>

        Identify associations between individual taxa/OTUs and environmental variables in a
        multivariate analysis.
        For each taxon a regression model is fit of the form:
        <p/>
        abundance of taxon = env1 + env2 + env3 ...,
        <p/>
        where env1, env2, ... are the environmental variables. For each taxon and each environmental
        variable the p-value (".p") and coefficient (".c") of the model are shown, indicating the effect of the environmental
        variable on the abundance of the respective taxon/OTU. The table can be sorted
        by clicking on the table header. 
        <p>
            Use the Taxa drop-down menu to select a specific taxon or OTU. For each environmental variable,
            two scatterplots are displayed. In the first plot, the abundance of the selected taxa/OTU
            is plotted versus the environmental variable. The Pearson correlation is given as 
            R, the p-value indicates the significance of the correlation.
            In the second plot, the abundance of the
            selected taxa/OTU is controlled by the values of all remaining environmental variables.
            The taxa/OTU abundance is controlled by first fitting a multiple linear regression model
            using all remaining environmental variables as explanatory variables.
            The residuals of this model are plotted versus the abundance of the bacterial
            group.
        <p/>
        <img src="resources/figures/tve-scatter.png" width="900" height="450" alt="tve-scatter"/>

        <p>For <bbu>paired data</bbu>, select the "Paired" checkbox. A linear mixed effects model is fit of the form:
        <p/>
        abundance of taxon = env1 + env2 + env3 ... + pair1 + pair2 + ...,
        <p/>
        where the environmental variables are included as fixed effects and the pairs as random effect.
        The model is fit in R using the following command: lmer(taxon ~ env1 + env2 + ... + (1|pair))
        <p>
            Use the Taxa drop-down menu to select a specific taxon or OTU. For each environmental 
            variable e,
            two scatterplots are displayed. In the first plot, the abundance of the selected taxa/OTU
            is plotted versus the environmental variable e. 
            In the second plot, the partial correlation
            is shown. The abundance of the
            selected taxa/OTU is controlled by the values of all remaining environmental variables
            (by fitting a regression model with the remaining environmental variables and plotting
            the residuals versus e).
            The Pearson correlation is given as R, the
            p-value indicates the significance of the correlation.
        </p>


        <h4>Taxa Time Series</h4>
        Analysis of longitudinal data (time series). The secondary group of each sample
        is used as time point. For each taxon/OTU, a mixed effect
        regression model is fit of the form:
        <p>
            abundance of taxa/OTU = time-point 1 + time-point 2 + ...  + pair1 + pair2 + ...,
        </p>
        where time point is included as fixed effect variable and pair as random effect parameter.
        This is calculated in R using the lmer() function and the formula: 
        taxon ~ as.factor(groupS) + (1|pair).
        <p>
            Use the Taxa drop-down menu to select a specific taxon or OTU. A boxplot of the abundance
            of the selected taxa is shown. Additionally, the abundance of the selected taxon is
            shown for each individual/environment (pair) as line.
        </p>
        <img src="resources/figures/longitudinal.png" width="400" height="330" alt="longitudinal"/>
        <p>


            <h4>Diversity vs Envp</h4>

        Identify associations between the community diversity and environmental parameters.
        The diversity index can be set by the "Index" drop down menu. Recommended indices are
        "Shannon" and "Richness".
        A regression model is fit of the form:
        <p/>
        diversity = env1 + env2 + env3 ...,
        <p/>
        where env1, env2, ... are the environmental variables. The generated table lists for each
        environmental variable the coefficient ("Estimate") and p-value. The p-value
        indicates if the environmental variable significantly effects the community diversity.
        <p/>
        Additionally, two scatterplots are shown for each environmental variable. The
        first plots the diversity of each sample versus the environmental variable. The
        p-value indicates the significance of the Pearson correlation between the community
        diversity and the environmental variable. In the second scatterplot, the diversity index
        is controlled for all remaining environmental variables.
        <p/>
        For paired data, select the "Paired" checkbox. The following regression model
        is fit for paired data:
        <p>
        difference in diversity (samples from same pair) = difference in env1 + difference in env2 + ...,
        </p> where env1, env2, ... are the environmental variables. The difference in diversity
        is computed for all combinations of samples from the SAME pair.
        <p/>
        <img src="resources/figures/dve.png" width="800" height="600" alt="dve"/>

<h3>Environmental variable</h3>

        Two tables are shown. First, the correlation (Pearson correlation) between each taxa and the selected
        dependent variable. A p-value is given indicating the statistical
        significance of the correlation. The second table summaries the results of the fitted regression model.
        For each bacterial group, the coefficient as well as a p-value are given. The p-value indicates if
        the respective bacterial groups has a significant contribution to the fitted regression model.

        <p></p>

        Additionally a scatter plot is presented, which visualizes how well the fitted model explains
        the dependant variable. The fitted model can be used to predict the dependent variable
        given the explanatory variable. The scatterplot displays for each sample the
        observed/original value of dependence variable (as specified in the meta data file) versus the
        predicted value (the value of the dependent variable as predicted by the fit model).
        A p-value of the statistical significance of the fitted model is given.
        <p/>
       Use the Taxa drop-down menu to select a specific taxon or OTU.  Four scatterplots are shown:
        <p></p>
        The first (top left) visualized the dependency of the
        dependant variable from the abundance of the selected bacterial group. Depicted
        is the value of the dependent variable versus the abundance of the selected bacterial group.
        <p></p>
        The second plot (upper right) depicts
        the controlled dependent variable versus the abundance of the bacterial group. The
        dependent variable is controlled by first fitting a multiple linear regression model
        using all remaining bacterial groups as explanatory variables. Subsequently, the simple
        linear regression model is fit on the residuals of the multiple linear regression model.
        <p></p>
        The third plot (lower left) depicts the partial correlation between the dependent variable
        and the selected bacterial group. The controlled dependent variable is plotted versus the
        controlled abundance of the bacterial group.
        <p></p>
        The fourth figure (lower right) visualize
        how well the fit linear regression model explains the value of the dependant variable, or
        in other words how strongly the dependant variable depends on the abundance of the selected
        bacterial group. Depicted is the the predicted value of the dependant variable (predicted by the fit simple linear regression
        model) versus the observed/original value of the the dependant variable (as specified in
        the meta data file).


         <h2><a name="biomarker">BM (Biomarker)</a></h2>
        Discovery of predictive biomarkers. For each phylotype a p-value (either by t-test, Wilcoxon test or regression),
        adjusted p-values (FDR or Bonferoni), Area Under the ROC Curve (AUC with 95% upper and lower
        confidence intervals), odds ratio (with 95% upper and lower confidence intervals), delta
        (difference in mean divided by standard deviation), and fold change are calculated. Odds ratios
        are visualized as forest plots. Together these values indicate if each taxa is a potential
        predictive biomarker for classifying samples into the two selected groups (Primary group by default).
        <p/>
        If test is set to "LogisticRegression" the p-value will be calculated by logistic regression, using the
        selected group (default: primary group) as dependent variable and all environmental variables as
        explanatory variables (group ~ phylotype + env1 + env2 + env3 + ..., where env1,... are the environmental variables
        specified in the metadata annotation file). Also AUC and odds ratio will be adjusted for all 
        environmental variables. In detail: odds ratios are calculated by logistic regression, all environmental
        variables are included as explanatory variables.
         

        <h2><a name="faq">FAQ</h2>
        <h4>Error message: An internal error occurred, likely you either didn't upload a data and meta data file
            or your session has expired.</h4>
        Before using Calypso, you need to upload a data and meta data file. Select <a href="faces/uploadFiles.jsp">Home</a> in the top menu and
        upload a data and meta data file or press "Start Demo Project". Make sure that
        you have activated java script in your browser settings and allow cookies. If you
        receive this error message after pressing "Start Demo Project" your browser does not
        allow cookies.
        You also receive
        this error message if your
        session has expired. The session expires not using Calypso for more than 60 minutes.

        <h4>Labels are only partially displayed in figure.</h4>
        Increase the figure width and height.
        
        <h4>CCA changes if "Color by" is changed, but CCA+ does not.</h4>
        CCA provides a p-value if variance observed in the community composition
        can be explained by the sample groups. The sample grouping can be selected
        by "Color by". CCA+ describes if variance in the community composition can
        be attributed to environmental variables. CCA+ does not include the sample groups
        for the statistical analysis. However, samples are colored by the grouping
        selected under "Color by".

        <h4>Labels overlap in figure.</h4>
        Increase the figure width and height.

        <h4>Figure legend overlaps with chart.</h4>
        Increase the figure width and height.



        <h4>Figures are completely white</h4>
        Solution: Reduce resolution of figure or increase figure width and height.

        <h4>Parsing counts file failed: ERROR: wrong format line 1, header is missing (no header tag for level ...)</h4>
        The data file is wrongly formated. Each header line has to contain the tag "header"

        <h4>Error message: Internal ERROR: null dataMatrix</h4>
        Likely you forgot to upload a data and/or meta data file. Select <a href="faces/uploadFiles.jsp">Home</a> in the top menu and
        upload a data and meta data file.

        <h4>Error message: j_id_id15:resolution: Validation Error: Value is not of the correct type.</h4>
        You have entered an incorrect value in one of the text fields. Valid value ranges are:<p>
            Resolution: 20-1000<p>
            Width: 20-10000<p>
            Height: 20-10000<p>
            Min proportion: 0-100, real numbers are supported, e.g. 0.2
    </div>

   
