<%-- 
    Document   : indexCalypso
    Created on : May 16, 2014, 4:50:07 PM
    Author     : lutzK
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>

<%@taglib prefix="f" uri="http://java.sun.com/jsf/core"%>
<%@taglib prefix="h" uri="http://java.sun.com/jsf/html"%>


<h2>Welcome to Calypso</h2>
                    Calypso is a software for the automated analysis and comparison of multiple and large 16S rDNA samples.
        The software provides a user-friendly, easy to use interface, allowing non expert users to mine, explore, interpret, visualize and
        compare large 16S rDNA datasets. Various powerful visualization techniques are provided, generating high quality figures that can readily
        be used in scientific publication. The software herewith facilitates:

        <ul>
            <li>detecting the affects of environmental perturbations on the composition and function of microbial communities</li>
            <li>identifying associations between human microorganisms and host phenotype</li>
            <li>reducing the
        complexity of the generated data sets to reveal interesting characteristics of the
        underlying microbial communities</li>
            <li>discovery of hidden patterns in the complex
        and multi-dimensional datasets</li>
        </ul>

        <h3>
        Recommended browsers: Firefox, Mozilla, and Safari. Internet Explorer can be used, but 
        some pages are not well rendered, embedded SVG figures are not supported and 
        interactive hierarchical trees are not functional.
                </h3>
        <h3>
        <a href="faces/uploadFiles.jsp">Start using Calypso</a>
        </h3>
        
        <p/><bbfl>
        Or get familiar with Calypso by following an example analysis in our
    <a href="http://cgenome.net:8080/html/wiki/index.php/Calypso#Tutorial">Tutorial</a></bbfl>
    

        <h2>Screenshots</h2>
        <img src="resources/figures/network1.png" width="400" height="400" alt="network1"/>
<img src="resources/figures/network2.png" width="400" height="400" alt="network2"/>


<img src="resources/figures/CircularTree.png" width="400" height="300" alt="Tree"/>
<img src="resources/figures/rda.png" width="400" height="300" alt="RDA"/>



<img src="resources/figures/network3.png" width="400" height="300" alt="network3"/>
<img src="resources/figures/anovaPlot.png" width="400" height="300" alt="anovaPlot"/>

<img src="resources/figures/hierachy.png" width="800" height="300" alt="hierarchy"/>

<img src="resources/figures/barchart.png" width="400" height="200" alt="barchart"/>\
<img src="resources/figures/dendro.png" width="400" height="200" alt="dendro"/>

<img src="resources/figures/heatmap.png" width="400" height="400" alt="heatmap"/>
<img src="resources/figures/bubble.png" width="400" height="400" alt="bubble"/>

<img src="resources/figures/cca.png" width="400" height="300" alt="cca"/>
<img src="resources/figures/pca.png" width="400" height="300" alt="pca"/>


<img src="resources/figures/som.png" width="450" height="350" alt="som"/>
<img src="resources/figures/boxplot.diversity.png" width="350" height="350" alt="som"/>



<img src="resources/figures/cca-group.png" width="400" height="320" alt="CCA Group"/>
<img src="resources/figures/otu-cor.png" width="400" height="320" alt="OTU correlation"/>

<img src="resources/figures/summary.png" width="400" height="200" alt="summary"/>
<img src="resources/figures/otu-div.png" width="400" height="200" alt="diversity"/>

<img src="resources/figures/rarefac.png" width="400" height="300" alt="rarefaction"/>


<p/>
    
<h2>Articles using Calypso</h2>
Umu ÖC, Frank JA, Fangel JU, Oostindjer M, da Silva CS, Bolhuis EJ, Bosch G, Willats WG, Pope PB, Diep DB.
Resistant starch diet induces change in the swine microbiome and a predominance of beneficial bacterial populations (2015). Microbiome.
<p/>
Ainsworth T, Krause L, …[12 authors]…, Leggat W. The coral core microbiome identifies rare bacterial taxa as ubiquitous endosymbionts (2015). ISME.
<p/>
Giacomin P, Zakrzewski M, Croese J, Su X, Sotillo J, McCann L, Navarro S, Mitreva M, Krause L, Loukas A, Cantacessi C. Experimental hookworm infection and escalating gluten challenges are associated with increased microbial richness in celiac subjects (2015). Scientific Reports. 
<p/>
Smith DJ, Badrick AC, Zakrzewski M, Krause L, Bell SC, Anderson GJ, Reid DW. Pyrosequencing reveals transient cystic fibrosis lung microbiome changes with intravenous antibiotics (2014). The European respiratory journal. 
<p/>
Dewar ML, Arnould JP, Krause L, Trathan P, Dann P, Smith SC. Influence of fasting during moult on the faecal microbiota of penguins (2014). PLoS One. 
<p/>
Swe PM, Zakrzewski M, Kelly A, Krause L, Fischer K. Scabies mites alter the skin microbiome and promote growth of opportunistic pathogens in a porcine model (2014). PLoS Negl Trop Dis, 8 (5). 
<p/> 
Smith, D.J., Badrick, A.C., Zakrzewski M, Krause, L., Bell, S.C., Anderson, G.J., Reid, D.W. Pyrosequencing reveals transient CF lung microbiome changes with intravenous antibiotics (2014). ERJ.
<p/>
Cantacessi C, Giacomin P, Croese J, Zakrzewski M, Sotillo J, McCann L, Nolan MJ, Mitreva M, Krause L**, Loukas A**. Impact of experimental hookworm infection on the human gut microbiota (2014). J Infect Dis. 
<p/>
Dewar ML, Arnould JP, Krause L, Dann P, Smith SC. Interspecific variations in the faecal microbiota of Procellariiform seabirds (2014). FEMS Microbiol Ecol. 
<p/>
Zhang L, Gowardman J, Morrison M, Krause L, Playford EG, Rickard CM. Molecular investigation of bacterial communities on intravascular catheters: no longer just Staphylococcus (2014). Eur J Clin Microbiol Infect Dis, 33 (7) 
<p/>
Plieskatt JL, Deenonpoe R, Mulvenna JP, Krause L, Sripa B, Bethony JM, Brindley PJ. Infection with the carcinogenic liver fluke Opisthorchis viverrini modifies intestinal and biliary microbiome (2013). FASEB J. 
<p/>
Reis, M., Roy, N., Bermingham, E., Ryan, L., Bibiloni, R., Young, W., Krause, L., Berger, B., North, M., Stelwagen, K., Reis, M. Impact of dietary dairy polar lipids on lipid metabolism of young mice fed high fat diet (2013). Journal of Agricultural and Food Chemistry.
